#################################################################################
##
##   R package rgarch by Alexios Ghalanos Copyright (C) 2009, 2010
##   This file is part of the R package rgarch.
##
##   The R package rgarch is free software: you can redistribute it and/or modify
##   it under the terms of the GNU General Public License as published by
##   the Free Software Foundation, either version 3 of the License, or
##   (at your option) any later version.
##
##   The R package rgarch is distributed in the hope that it will be useful,
##   but WITHOUT ANY WARRANTY; without even the implied warranty of
##   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
##   GNU General Public License for more details.
##
#################################################################################


#################################################################################
# GO-GARCH model
#################################################################################
# Fit versus Filter
rgarch.test111 = function()
{
	cat("\nrgarch-->test11-1: GO-GARCH Functionality\n")
	data(dji30ret)
	
	
	spec = gogarchspec(mean.model = list(demean = "constant", lag.max = 4, lag.criterion = "HQ"), 
			ica = "fastica", variance.model = list(model = "sGARCH"),
			distribution.model = list(distribution = "mvnorm"))
	
	fit = gogarchfit(spec, data = dji30ret[,1:4], out.sample = 100, gfun = "tanh")
	flt = gogarchfilter(fit, data = dji30ret[,1:4], out.sample = 100)
	
	options(width = 120)
	zz <- file("test11-1.txt", open="wt")
	sink(zz)
	cat("\nGO-GARCH Fit-Filter Check:\n")
	cat("\nUnivariate Sigma Estimates (Fit)\n")
	head(fit@mfit$sigmas,3)	
	cat("\nUnivariate Sigma Estimates (Filter)\n")
	head(flt@mfilter$sigmas,3)
	cat("\nFirst Covariance (Fit)\n")
	rcov(fit)[,, 1]
	cat("\nFirst Covariance (Filter)\n")
	rcov(flt)[,, 1]
	sink(type="message")
	sink()
	close(zz)
	
}
